-- RZ_DM_QUANTILE ZB_DM_单位时间内访问时间排序

-- QUANTILE_AGENTID 单位时间内访问时间排序按应用统计
insert into RZ_DM.RZ_DM_MYSQL.QUANTILE_AGENTID
SELECT
    s1.`applicationname`                           as `applicationname`
    ,s1.`agentid`                                  as `agentid`
    ,s1.`time`                                     as `time`
    ,SPLIT_INDEX(s1.`quantile`,';',0)              as `quantile50`
    ,SPLIT_INDEX(s1.`quantile`,';',1)              as `quantile75`
    ,SPLIT_INDEX(s1.`quantile`,';',2)              as `quantile95`
    ,SPLIT_INDEX(s1.`quantile`,';',3)              as `quantile99`
    ,cast(DateTimeToLongUDF() as varchar)          as `createtime`
from(
    select
        c1.`applicationname`                               as `applicationname`
        ,c1.`agentid`                                      as `agentid`
        ,c1.`time`                                         as `time`
        ,CastToTagIndexUDF(c1.`lists`)                     as `quantile` -- 自定义数组排序函数
    from (
        select
            d1.`applicationName`                                                    as `applicationname`
            ,d1.`agentId`                                                           as `agentid`
            ,CONCAT(LongTimeToStringUDF(cast(d1.endTime as bigint)+60000,'yyyy-MM-dd HH:mm'),':00' )      as `time`
            ,LISTAGG(d1.`elapsed`,';')                                              as `lists` -- 拼接
        from RZ_ODS.RZ_ODS_KAFKA.RZDATA d1
        where
            LongTimeToStringUDF(d1.endTime,'yyyy-MM-dd HH:mm') >= DATE_FORMAT(TIMESTAMPADD(MINUTE,-1,LOCALTIMESTAMP),'yyyy-MM-dd HH:mm')
            and LongTimeToStringUDF(d1.endTime,'yyyy-MM-dd HH:mm') < DATE_FORMAT(TIMESTAMPADD(MINUTE,+1,LOCALTIMESTAMP),'yyyy-MM-dd HH:mm')
            and d1.status = '200'
            and RIGHT(d1.`rpc`,3) not in ('.js')
            and RIGHT(d1.`rpc`,4) not in ('.jpg','.ico','.css','.ttf','.png','.PNG','.JPG','.txt','.mp4','.mp3','.pdf','.dwr')
            and RIGHT(d1.`rpc`,5) not in ('.json','.html','.less','.jpeg')
            and RIGHT(d1.`rpc`,6) not in ('.woff2')
        group by
             d1.`applicationName`
            ,d1.`agentId`
            ,CONCAT(LongTimeToStringUDF(cast(d1.endTime as bigint)+60000,'yyyy-MM-dd HH:mm'),':00' )
    ) c1
) s1
;


-- QUANTILE_APP 单位时间内访问时间排序按集群统计
insert into RZ_DM.RZ_DM_MYSQL.QUANTILE_APP
SELECT
    s1.`applicationname`                           as `applicationname`
    ,s1.`time`                                     as `time`
    ,SPLIT_INDEX(s1.`quantile`,';',0)              as `quantile50`
    ,SPLIT_INDEX(s1.`quantile`,';',1)              as `quantile75`
    ,SPLIT_INDEX(s1.`quantile`,';',2)              as `quantile95`
    ,SPLIT_INDEX(s1.`quantile`,';',3)              as `quantile99`
    ,cast(DateTimeToLongUDF() as varchar)          as `createtime`
from(
    select
        c1.`applicationname`                               as `applicationname`
        ,c1.`time`                                         as `time`
        ,CastToTagIndexUDF(c1.`lists`)                     as `quantile`
    from (
        select
            d1.`applicationName`                                                    as `applicationname`
            ,CONCAT(LongTimeToStringUDF(cast(d1.endTime as bigint)+60000,'yyyy-MM-dd HH:mm'),':00' )      as `time`
            ,LISTAGG(d1.`elapsed`,';')                                              as `lists` -- 拼接
        from RZ_ODS.RZ_ODS_KAFKA.RZDATA d1
        where
            LongTimeToStringUDF(d1.endTime,'yyyy-MM-dd HH:mm') >= DATE_FORMAT(TIMESTAMPADD(MINUTE,-1,LOCALTIMESTAMP),'yyyy-MM-dd HH:mm')
            and LongTimeToStringUDF(d1.endTime,'yyyy-MM-dd HH:mm') < DATE_FORMAT(TIMESTAMPADD(MINUTE,+1,LOCALTIMESTAMP),'yyyy-MM-dd HH:mm')
            and d1.status = '200'
            and RIGHT(d1.`rpc`,3) not in ('.js')
            and RIGHT(d1.`rpc`,4) not in ('.jpg','.ico','.css','.ttf','.png','.PNG','.JPG','.txt','.mp4','.mp3','.pdf','.dwr')
            and RIGHT(d1.`rpc`,5) not in ('.json','.html','.less','.jpeg')
            and RIGHT(d1.`rpc`,6) not in ('.woff2')
        group by
             d1.`applicationName`
            ,CONCAT(LongTimeToStringUDF(cast(d1.endTime as bigint)+60000,'yyyy-MM-dd HH:mm'),':00' )
    ) c1
) s1
;







