-- RZ_DM_RUNSTATUS RZ_DM_访问次数

-- 视图
-- step1：
-- 接口汇总
CREATE TEMPORARY VIEW VIEW_RZ_DM_RUNSTATUS AS 
     s1.applicationname                                                      as `applicationname`        
    ,s1.agentid                                                              as `agentid`                
    ,s1.endpoint                                                             as `endpoint`               
    ,s1.rpc                                                                  as `rpc`             
    ,concat(LongTimeToStringUDF(cast(s1.endTime as bigint)*60000,'yyyy-MM-dd HH:mm'),":00" )       as `time`
    ,AVG(s1.elapsed   )                                                      as `averageelapsed`     
    ,sum(1)                                                                  as `total`              
    ,sum(if(s1.status = '200',1,0))                                          as `suctotal`           
    ,sum(if(s1.status = '200' is not true,1,0))                              as `errortotal`         
    ,DateTimeToLongUDF()                                                     as `createtime`       
from RZ_ODS.RZ_ODS_KAFKA_RZ.RZDATA s1
where 
    LongTimeToStringUDF(s1.endTime,'yyyy-MM-dd HH:mm') > DATEFORMAT(TIMESTAMPADD(MINUTE,-3,LOCALTIMESTAMP),'yyyy-MM-dd HH:mm')
group by 
     s1.applicationname  
    ,s1.agentid          
    ,s1.endpoint         
    ,s1.rpc              
    ,concat(LongTimeToStringUDF(cast(s1.endTime as bigint)*60000,'yyyy-MM-dd HH:mm'),":00" )
;

-- RZ_DM_RUNSTATUS_URL RZ_DM_访问次数按地址统计
insert into RZ_DM.RZ_DM_MYSQL.RZDATARZ_DM_RUNSTATUS_URL
select
     s1.`applicationname`
    ,s1.`agentid`        
    ,s1.`endpoint`       
    ,s1.`rpc`            
    ,s1.`time`           
    ,s1.`averageelapsed` 
    ,s1.`total`          
    ,s1.`suctotal`       
    ,s1.`errortotal`     
    ,s1.`createtime`     
from VIEW_RZ_DM_RUNSTATUS s1 
;


-- RZ_DM_RUNSTATUS_AGENTID RZ_DM_访问次数按应用统计
insert into RZ_DM.RZ_DM_MYSQL.RZ_DM_RUNSTATUS_AGENTID
select
     s1.`applicationname`
    ,s1.`agentid`                   
    ,s1.`time`           
    ,s1.`averageelapsed` 
    ,s1.`total`          
    ,s1.`suctotal`       
    ,s1.`errortotal`     
    ,s1.`createtime`     
from VIEW_RZ_DM_RUNSTATUS s1 
group by
     s1.`applicationname`
    ,s1.`agentid`                   
    ,s1.`time`           
    ,s1.`averageelapsed` 
    ,s1.`total`          
    ,s1.`suctotal`       
    ,s1.`errortotal`     
    ,s1.`createtime`  
;


-- RZ_DM_RUNSTATUS_APP RZ_DM_访问次数按集群统计
insert into RZ_DM.RZ_DM_MYSQL.RZ_DM_RUNSTATUS_APP
select
     s1.`applicationname`         
    ,s1.`time`           
    ,s1.`averageelapsed` 
    ,s1.`total`          
    ,s1.`suctotal`       
    ,s1.`errortotal`     
    ,s1.`createtime`     
from VIEW_RZ_DM_RUNSTATUS s1 
group by 
     s1.`applicationname`         
    ,s1.`time`           
    ,s1.`averageelapsed` 
    ,s1.`total`          
    ,s1.`suctotal`       
    ,s1.`errortotal`     
    ,s1.`createtime`  
;
